#include "Init.h"

unsigned char WriteData[Flash_Page_Size];
unsigned char ReadData[Flash_Page_Size];

unsigned char BadBlockTable[Flash_Blocks];
int i, Flag1, Flag2 = 0 ;

unsigned int ByteNo = 4; // used in Random Inout & Output API's
unsigned int PageNo  =  15;
unsigned int BlockNo = 7;
unsigned char DataInput = 0x5A;
unsigned char DataOutput ;


// For CopyBack API
unsigned int SrcPageNo   = 10;
unsigned int SrcBlockNo  = 6;
unsigned int DestPageNo  = 12;
unsigned int DestBlockNo = 7;


// Flash Commands

char BlockEraseCmd[2]		= 	{ 0x60, 0xD0 };
char PageReadCmd[2] 		= 	{ 0x00, 0x30 };
char PageWriteCmd[2] 		= 	{ 0x80, 0x10 };
char StatusReadCmd[1]		=	{ 0x70 };
char RandomDataInputCmd[1]	= 	{ 0x85 };		
char RandomDataOutputCmd[2]	= 	{ 0x05, 0xE0 };	
char CopyBackCmd[4] 		=	{ 0x00, 0x35, 0x85, 0x10 };


// Function declarations

void Init(void);
void BlockErase(unsigned int Eblock);	
void PageWrite(unsigned int Wpage, unsigned int Wblock, unsigned char *Write_Buf);
void PageRead(unsigned int Rpage, unsigned int Rblock, unsigned char *Read_Buf);
void RandomDataInput(unsigned int RIbyte, unsigned int RIpage, unsigned int RIblock, unsigned char DataIn);
void RandomDataOutput(unsigned int RObyte, unsigned int ROpage, unsigned int ROblock, unsigned char DataOut);
void CopyBack(unsigned int SrcPage, unsigned int SrcBlock,unsigned int DestPage, unsigned int DestBlock);
void Error_Analysis(void);
short Read_Flash_Status_Register(void);

